<?php

namespace Drupal\jsonapi_permission_access\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Class JsonApiRoutesAddPermission.
 *
 * Adds a specific permission to JSON:API routes.
 */
class JsonApiRoutesAddPermission extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    foreach ($collection as $route) {
      $defaults = $route->getDefaults();
      if (!empty($defaults['_is_jsonapi'])) {
        $route->setRequirement('_permission', 'access jsonapi routes');
      }
    }
  }

}
